function FinancialInfoGadget()
{
	var thisObj 		= this;
	
	this.FinInfoArray 	= new Array();
	this.txtAlign 		= "center";
	this.updateInterval = 60;
	this.feedURL 		= "http://infovalutar.ro/cursuri.rss";
	this.feedManager 	= null;
	this.feed 			= null;
	this.flyoutVisible 	= false;
	
	this.init = function()
	{
		System.Gadget.settingsUI 		= "settings.html";
	    System.Gadget.onSettingsClosed  = this.reloadGadget;
		
		this.FinInfoArray[0] = { CURRENCY : "USD", HIDE : false, VALUE : 0}
		this.FinInfoArray[1] = { CURRENCY : "EUR", HIDE : false, VALUE : 0}
		this.FinInfoArray[2] = { CURRENCY : "GBP", HIDE : false, VALUE : 0}
		this.FinInfoArray[3] = { CURRENCY : "XDR", HIDE : false, VALUE : 0}
		this.FinInfoArray[4] = { CURRENCY : "XAU", HIDE : false, VALUE : 0}
		this.FinInfoArray[5] = { CURRENCY : "TRY", HIDE : false, VALUE : 0}
		this.FinInfoArray[6] = { CURRENCY : "SEK", HIDE : false, VALUE : 0}
		this.FinInfoArray[7] = { CURRENCY : "PLN", HIDE : false, VALUE : 0}
		this.FinInfoArray[8] = { CURRENCY : "NOK", HIDE : false, VALUE : 0}
		this.FinInfoArray[9] = { CURRENCY : "MDL", HIDE : false, VALUE : 0}
		this.FinInfoArray[10]= { CURRENCY : "JPY", HIDE : false, VALUE : 0}
		this.FinInfoArray[11]= { CURRENCY : "HUF", HIDE : false, VALUE : 0}
		this.FinInfoArray[12]= { CURRENCY : "EGP", HIDE : false, VALUE : 0}
		this.FinInfoArray[13]= { CURRENCY : "DKK", HIDE : false, VALUE : 0}
		this.FinInfoArray[14]= { CURRENCY : "CZK", HIDE : false, VALUE : 0}
		this.FinInfoArray[15]= { CURRENCY : "CHF", HIDE : false, VALUE : 0}
		this.FinInfoArray[16]= { CURRENCY : "CAD", HIDE : false, VALUE : 0}
		this.FinInfoArray[17]= { CURRENCY : "AUD", HIDE : false, VALUE : 0}
		
		this.loadSettings();
		
		try
		{
			this.feedManager = new ActiveXObject("Microsoft.FeedsManager");
			if (this.feedManager != null)
			{
				this.initFeed();
			}
			else
			{
				this.showError();
			}
		}
		catch (e)
		{
			this.showError();
		}
	}
	
	this.showError = function()
	{
		var gadgetBody 	= document.getElementById('GadgetBody');

		gadgetBody = '<div id="ERROR">&nbsp;</div>';
	}
	
	this.initFeed = function()
	{
		if (this.feedManager.ExistsFeed("InfoValutarRo"))
		{
			this.feedManager.DeleteFeed("InfoValutarRo");
		}
		
		this.feedManager.RootFolder.CreateFeed("InfoValutarRo", this.feedURL);
		this.feed = this.feedManager.GetFeed("InfoValutarRo");
		
		if (this.feed)
		{
			this.refreshFeed();
		}
		else
		{
			setTimeout(function() { thisObj.initFeed(); }, 60000);
		}
	}
	
	this.run = function()
	{
		this.init();
	}

	this.refreshFeed = function()
	{
		this.feed.Download();

		for (var i = 0 ; i < this.feed.Items.Count ; i++ )
		{
			this.updateCurrency(this.feed.Items.item(i).Title, this.feed.Items.item(i).Description);
		}

		this.refreshGadget();
		
		setTimeout(function() { thisObj.refreshFeed(); }, 60000 * this.updateInterval);
	}
	
	this.updateCurrency = function(_currency, _value)
	{
		for (var i in this.FinInfoArray)
		{
			if (this.FinInfoArray[i].CURRENCY == _currency)
			{
				this.FinInfoArray[i].VALUE = _value;
			}
		}
	}
	
	this.refreshGadget = function()
	{
		var gadgetBody 	= document.getElementById('GadgetBody');
		var gadgetHtml 	= "";
		var gadgetSize 	= 29;
		
		for (var i in this.FinInfoArray)
		{
			if (this.FinInfoArray[i].HIDE != true)
			{
				gadgetHtml += 	'<div id="' + this.FinInfoArray[i].CURRENCY + '"><div align="' + this.txtAlign + 
								'" id="' + this.FinInfoArray[i].CURRENCY + 'content">' + this.FinInfoArray[i].CURRENCY + 
								' = ' + this.FinInfoArray[i].VALUE + ' RON</div></div>';
				gadgetSize += 23;
			}
		}
		gadgetHtml += '<div id="btnCurrencyCalculator"><a href="javascript:Gadget.showCurrencyCalculator();" onmouseover="javascript:Gadget.RollOver(true);"' +
						'onmouseout="javascript:Gadget.RollOver(false);"><img id="btnCurrency" src="images/btnCurrencyN.png" width="130" height="17" border="0" /></a></div>';
		gadgetBody.innerHTML = gadgetHtml;

		this.resizeGadget(gadgetSize);
	}
	
	this.reloadGadget = function()
	{
		thisObj.loadSettings();
		thisObj.refreshGadget();
	}
	
	this.resizeGadget = function(_newSize)
	{
		document.getElementById('GadgetBody').style.height = _newSize + "px";
	}
	
	this.loadSettings = function()
	{								
		if ( System.Gadget.Settings.read("txtAlign") == "" )
		{
			System.Gadget.Settings.write("txtAlign", "center"); 
		}

		if ( System.Gadget.Settings.read("updateInterval") == "" )
		{
			System.Gadget.Settings.write("updateInterval", 5); 
		}

		this.FinInfoArray[0].HIDE  = System.Gadget.Settings.read("showUsd");
		this.FinInfoArray[1].HIDE  = System.Gadget.Settings.read("showEur");
		this.FinInfoArray[2].HIDE  = System.Gadget.Settings.read("showGbp");
		this.FinInfoArray[3].HIDE  = System.Gadget.Settings.read("showXdr");
		this.FinInfoArray[4].HIDE  = System.Gadget.Settings.read("showXau");
		this.FinInfoArray[5].HIDE  = System.Gadget.Settings.read("showTry");
		this.FinInfoArray[6].HIDE  = System.Gadget.Settings.read("showSek");
		this.FinInfoArray[7].HIDE  = System.Gadget.Settings.read("showPln");
		this.FinInfoArray[8].HIDE  = System.Gadget.Settings.read("showNok");
		this.FinInfoArray[9].HIDE  = System.Gadget.Settings.read("showMdl");
		this.FinInfoArray[10].HIDE = System.Gadget.Settings.read("showJpy");
		this.FinInfoArray[11].HIDE = System.Gadget.Settings.read("showHuf");
		this.FinInfoArray[12].HIDE = System.Gadget.Settings.read("showEgp");
		this.FinInfoArray[13].HIDE = System.Gadget.Settings.read("showDkk");
		this.FinInfoArray[14].HIDE = System.Gadget.Settings.read("showCzk");
		this.FinInfoArray[15].HIDE = System.Gadget.Settings.read("showChf");
		this.FinInfoArray[16].HIDE = System.Gadget.Settings.read("showCad");
		this.FinInfoArray[17].HIDE = System.Gadget.Settings.read("showAud");

		this.txtAlign = System.Gadget.Settings.read("txtAlign");
		this.updateInterval = System.Gadget.Settings.read("updateInterval");
	}
	
	this.showCurrencyCalculator = function()
	{
		System.Gadget.Flyout.file = "flyout.html";
        System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
	}
	
	this.RollOver = function(_over)
	{
		if (_over)
		{
			document.getElementById('btnCurrency').src = 'images/btnCurrencyO.png';
		}
		else
		{
			document.getElementById('btnCurrency').src = 'images/btnCurrencyN.png';
		}
	}
}